=== debian/changelog ===
librime (1.8.3+dfsg1-1+rpi1) bookworm-staging; urgency=medium

  * Disable dh_dwz.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 02 Feb 2023 19:41:30 +0000

librime (1.8.3+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Import latest plugin versions in 2023.
  * debian/librime1.shlibs: Tighten version requirement to current.

 -- Boyuan Yang <byang@debian.org>  Fri, 27 Jan 2023 10:32:43 -0500
