=== debian/changelog ===
librime (1.8.5+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Dropped, merged upstream.
  * debian/librime1.shlibs: Tighten version requirement to current.
  * debian/copyright: Refresh information.

 -- Boyuan Yang <byang@debian.org>  Wed, 08 Feb 2023 19:19:08 -0500

librime (1.8.3+dfsg1-2) unstable; urgency=medium

  * New upstream release:
    + Backport patches to match upstream 1.8.4 release.

 -- Boyuan Yang <byang@debian.org>  Mon, 30 Jan 2023 21:48:51 -0500
