=== debian/rules ===
--- 
+++ 
@@ -45,6 +45,3 @@
 	dh_gencontrol -plibrime-plugin-octagram -- \
 	        -v$(DEB_VERSION_EPOCH_UPSTREAM)~git$(REV_OCTAGRAM)-$(_DEB_VERSION_REVISION)
 	dh_gencontrol --remaining-packages
-
-override_dh_dwz:
-	echo dh_dwz disabled
