=== debian/changelog ===
librime (1.9.0+dfsg1-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:51:19 +0100

librime (1.9.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/clean: Update to fix build failure after successful build.
    (Closes: #1046487)
  * debian/librime1.shlibs: Bump minimum version to 1.9.0.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 Sep 2023 17:30:44 -0400

librime (1.9.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh plugin versions:
    + charcode: 20230904
    + lua: 20230917
    + octagram: 20230125
  * debian/watch: Update file exclusion patterns.
  * debian/patches/0001-Use-googletest-lib-built-from-source.patch:
    Add patch to use system googletest source code for unit tests.
  * debian/rules: Enable testing accordingly.

 -- Boyuan Yang <byang@debian.org>  Thu, 21 Sep 2023 20:46:35 -0400

librime (1.8.5+dfsg1-2) unstable; urgency=medium

  [ xiao sheng wen ]
  * debian/clean: Add trailing slash for dh_clean compatibility with
    new debhelper.

 -- Boyuan Yang <byang@debian.org>  Sat, 05 Aug 2023 20:11:59 -0400
