=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  cmake (>= 3.10),
  darts,
  debhelper-compat (= 13),
+ googletest <!nocheck>,
  libboost-dev,
  libboost-filesystem-dev,
  libboost-locale-dev,
