=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,17 @@
 include /usr/share/dpkg/default.mk
 
 # For individual package versions
-REV_CHARCODE = 20230125
-REV_LUA = 20230115
+REV_CHARCODE = 20230904
+REV_LUA = 20230917
 REV_OCTAGRAM = 20230125
 
 _DEB_VERSION_REVISION = $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//g')
+
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	LIBRIME_BUILD_TEST_FLAG := ON
+else
+	LIBRIME_BUILD_TEST_FLAG := OFF
+endif
 
 %:
 	dh $@ --buildsystem=cmake
@@ -25,9 +31,10 @@
 	    -DINSTALL_PRIVATE_HEADERS=ON \
 	    -DENABLE_EXTERNAL_PLUGINS=ON \
 	    -DBOOST_USE_CXX11=ON \
-	    -DBUILD_TEST=OFF \
+	    -DBUILD_TEST=$(LIBRIME_BUILD_TEST_FLAG) \
 	    -DBUILD_MERGED_PLUGINS=Off \
-	    -DENABLE_EXTERNAL_PLUGINS=On
+	    -DENABLE_EXTERNAL_PLUGINS=On \
+	    $(NULL)
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k CHANGELOG.md
